# FunctionChains.jl

FunctionChains.jl implements chained functions with functionality beyond `Base.ComposedFunction`.

The package defines the function [`fchain`](@ref) that can turn `Tuple`s, `AbstractVector`s or iterators over functions into a composed function. Functions are applied in the order they are given in the collection, so `fchain((f, g, h))` is equivalent to `h ∘ g ∘ f`.

The composed function generated by `fchain` supports `InverseFunctions.inverse` and/or `ChangesOfVariables.with_logabsdet_jacobian` if all functions in the chain do so.
